VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3255
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4590
   LinkTopic       =   "Form1"
   ScaleHeight     =   3255
   ScaleWidth      =   4590
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      Height          =   2895
      Left            =   120
      ScaleHeight     =   2835
      ScaleWidth      =   4275
      TabIndex        =   0
      Top             =   240
      Width           =   4335
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuObjects 
      Caption         =   "&Objects"
      Begin VB.Menu mnuObjectsRectangle 
         Caption         =   "&Rectangle"
      End
      Begin VB.Menu mnuObjectsCircle 
         Caption         =   "&Circle"
      End
      Begin VB.Menu mnuObjectsLine 
         Caption         =   "&Line"
      End
   End
   Begin VB.Menu mnuAttributes 
      Caption         =   "&Attributes"
      Enabled         =   0   'False
      Begin VB.Menu mnuAttributesDelete 
         Caption         =   "&Delete"
      End
      Begin VB.Menu mnuAttributesBorder 
         Caption         =   "&Border"
         Begin VB.Menu mnuAttributesBorderColor 
            Caption         =   "&Color"
            Begin VB.Menu mnuAttributesBorderColorBlack 
               Caption         =   "&Black"
            End
            Begin VB.Menu mnuAttributesBorderColorWhite 
               Caption         =   "&White"
            End
            Begin VB.Menu mnuAttributesBorderColorRed 
               Caption         =   "&Red"
            End
            Begin VB.Menu mnuAttributesBorderColorGreen 
               Caption         =   "&Green"
            End
            Begin VB.Menu mnuAttributesBorderColorBlue 
               Caption         =   "B&lue"
            End
         End
         Begin VB.Menu mnuAttributesBorderThickness 
            Caption         =   "&Thickness"
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&1"
               Index           =   1
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&2"
               Index           =   2
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&3"
               Index           =   3
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&4"
               Index           =   4
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&5"
               Index           =   5
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&6"
               Index           =   6
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&7"
               Index           =   7
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&8"
               Index           =   8
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&9"
               Index           =   9
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&10"
               Index           =   10
            End
         End
      End
      Begin VB.Menu mnuAttributesColor 
         Caption         =   "&Color"
         Begin VB.Menu mnuAttributesColorBlack 
            Caption         =   "&Black"
         End
         Begin VB.Menu mnuAttributesColorWhite 
            Caption         =   "&White"
         End
         Begin VB.Menu mnuAttributesColorRed 
            Caption         =   "&Red"
         End
         Begin VB.Menu mnuAttributesColorGreen 
            Caption         =   "&Green"
         End
         Begin VB.Menu mnuAttributesColorBlue 
            Caption         =   "B&lue"
         End
         Begin VB.Menu mnuAttributesColorTransparentSep 
            Caption         =   "-"
         End
         Begin VB.Menu mnuAttributesColorTransparent 
            Caption         =   "&Transparent"
         End
      End
      Begin VB.Menu mnuAttributesPosition 
         Caption         =   "&Position"
         Begin VB.Menu mnuAttributesPositionToTop 
            Caption         =   "Top &Top"
            Shortcut        =   ^J
         End
         Begin VB.Menu mnuAttributesPositionToBottom 
            Caption         =   "To &Bottom"
            Shortcut        =   ^K
         End
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Enum DrawingState
    state_None          ' Not drawing.
    state_Rectangle     ' Drawing a rectangle.
    state_Circle        ' Drawing a circle.
    state_Line          ' Drawing a line.
End Enum

' Tells what we are trying to do.
Private m_State As DrawingState

' True when the mouse is down during draw.
Private m_Drawing As Boolean

' Coordinates of the first and last points
' for a new object.
Private m_FirstX As Single
Private m_FirstY As Single
Private m_LastX As Single
Private m_LastY As Single

' All of the drawing objects.
Private m_DrawingObjects As Collection

' The currently selected object.
Private m_SelectedObject As Object
' Redraw all objects.
Private Sub Redraw()
Dim obj As Object

    picCanvas.Cls

    For Each obj In m_DrawingObjects
        obj.Draw
    Next obj
End Sub

' Remove the selected object from the
' m_DrawingObjects collection.
Private Sub RemoveSelectedObject()
Dim i As Integer

    ' Find the selected object's current position.
    For i = 1 To m_DrawingObjects.Count
        If m_DrawingObjects(i) Is m_SelectedObject Then Exit For
    Next i

    ' Remove the object.
    m_DrawingObjects.Remove i
End Sub
' Select the object (it may be Nothing).
Private Sub SelectObject(obj As Object)
    ' Deselect the previously selected object if any.
    If Not m_SelectedObject Is Nothing Then
        m_SelectedObject.Selected = False
    End If

    ' Select the new object.
    Set m_SelectedObject = obj
    If Not m_SelectedObject Is Nothing Then
        m_SelectedObject.Selected = True
    End If

    ' Enable or disable the Attributes accordingly.
    mnuAttributes.Enabled = (Not m_SelectedObject Is Nothing)

    ' Check the menus for the object's attributes.
    CheckMenus

    ' Redraw.
    Redraw
End Sub
' Check the right menu items for the selected object.
Private Sub CheckMenus()
Dim ctl As Control

    If m_SelectedObject Is Nothing Then Exit Sub

    ' Uncheck all menu items
    For Each ctl In Controls
        If TypeOf ctl Is Menu Then ctl.Checked = False
    Next ctl

    ' Check the right items for this object.
    ' Fore color.
    Select Case m_SelectedObject.ForeColor
        Case vbBlack
            mnuAttributesBorderColorBlack.Checked = True
        Case vbBlue
            mnuAttributesBorderColorBlue.Checked = True
        Case vbGreen
            mnuAttributesBorderColorGreen.Checked = True
        Case vbRed
            mnuAttributesBorderColorRed.Checked = True
        Case vbWhite
            mnuAttributesBorderColorWhite.Checked = True
    End Select

    ' Fill color.
    If m_SelectedObject.FillStyle = vbFSTransparent Then
        mnuAttributesColorTransparent.Checked = True
    Else
        Select Case m_SelectedObject.FillColor
            Case vbBlack
                mnuAttributesColorBlack.Checked = True
            Case vbBlue
                mnuAttributesColorBlue.Checked = True
            Case vbGreen
                mnuAttributesColorGreen.Checked = True
            Case vbRed
                mnuAttributesColorRed.Checked = True
            Case vbWhite
                mnuAttributesColorWhite.Checked = True
        End Select
    End If

    ' Border thickness.
    mnuAttributesBorderThick(m_SelectedObject.DrawWidth).Checked = True
End Sub

' Find the object at this position.
Private Function ObjectAt(ByVal X As Single, ByVal Y As Single) As Object
Dim i As Integer

    ' See if an object is here. Look from top
    ' to bottom.
    For i = m_DrawingObjects.Count To 1 Step -1
        If m_DrawingObjects(i).IsAt(X, Y) Then Exit For
    Next i

    If i > 0 Then
        Set ObjectAt = m_DrawingObjects(i)
    Else
        Set ObjectAt = Nothing
    End If
End Function
Private Sub Form_Load()
    Set m_DrawingObjects = New Collection
End Sub

Private Sub Form_Resize()
    picCanvas.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub mnuAttributesBorderColorBlack_Click()
    m_SelectedObject.ForeColor = vbBlack
    CheckMenus
    Redraw
End Sub

Private Sub mnuAttributesBorderColorBlue_Click()
    m_SelectedObject.ForeColor = vbBlue
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesBorderColorGreen_Click()
    m_SelectedObject.ForeColor = vbGreen
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesBorderColorRed_Click()
    m_SelectedObject.ForeColor = vbRed
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesBorderColorWhite_Click()
    m_SelectedObject.ForeColor = vbWhite
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesBorderThick_Click(Index As Integer)
    m_SelectedObject.DrawWidth = Index
    CheckMenus
    Redraw
End Sub
Private Sub mnuAttributesColorBlack_Click()
    m_SelectedObject.FillColor = vbBlack
    m_SelectedObject.FillStyle = vbFSSolid
    CheckMenus
    Redraw
End Sub

Private Sub mnuAttributesColorBlue_Click()
    m_SelectedObject.FillColor = vbBlue
    m_SelectedObject.FillStyle = vbFSSolid
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesColorGreen_Click()
    m_SelectedObject.FillColor = vbGreen
    m_SelectedObject.FillStyle = vbFSSolid
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesColorRed_Click()
    m_SelectedObject.FillColor = vbRed
    m_SelectedObject.FillStyle = vbFSSolid
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesColorTransparent_Click()
    m_SelectedObject.FillStyle = vbFSTransparent
    CheckMenus
    Redraw
End Sub


Private Sub mnuAttributesColorWhite_Click()
    m_SelectedObject.FillColor = vbWhite
    m_SelectedObject.FillStyle = vbFSSolid
    CheckMenus
    Redraw
End Sub


' Delete the selected object.
Private Sub mnuAttributesDelete_Click()
    ' Remove the object from m_DrawingObjects.
    RemoveSelectedObject

    ' Select no obect.
    SelectObject Nothing

    Redraw
End Sub

' Move the selected object to the top of the list.
Private Sub mnuAttributesPositionToTop_Click()
    ' Remove the object from m_DrawingObjects.
    RemoveSelectedObject

    ' Readd the object at the top of the list.
    m_DrawingObjects.Add m_SelectedObject

    Redraw
End Sub
' Move the selected object to the bottom of the list.
Private Sub mnuAttributesPositionToBottom_Click()
    ' Remove the object from m_DrawingObjects.
    RemoveSelectedObject

    ' Readd the object at the bottom of the list.
    If m_DrawingObjects.Count > 0 Then
        m_DrawingObjects.Add m_SelectedObject, , 1
    Else
        m_DrawingObjects.Add m_SelectedObject
    End If

    Redraw
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub
' Start drawing a circle.
Private Sub mnuObjectsCircle_Click()
    m_State = state_Circle
    picCanvas.MousePointer = vbCrosshair
End Sub

' Start drawing a line.
Private Sub mnuObjectsLine_Click()
    m_State = state_Line
    picCanvas.MousePointer = vbCrosshair
End Sub


' Start drawing a rectangle.
Private Sub mnuObjectsRectangle_Click()
    m_State = state_Rectangle
    picCanvas.MousePointer = vbCrosshair
End Sub

Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' See what we are doing.
    Select Case m_State
        Case state_None          ' Not drawing.
            ' Select the object at (X, Y).
            SelectObject ObjectAt(X, Y)

        Case Else
            ' If this is the left button,
            ' start drawing the new object.
            ' Set drawing parameters for drawing
            ' the new object.
            With picCanvas
                .DrawMode = vbInvert
                .FillStyle = vbFSTransparent
                .DrawWidth = 1
            End With

            m_Drawing = True
            m_FirstX = X
            m_FirstY = Y
            m_LastX = X
            m_LastY = Y
    End Select
End Sub

' Continue drawing.
Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim r As Single

    If Not m_Drawing Then Exit Sub

    ' Erase the old object.
    Select Case m_State
        Case state_None          ' Not drawing.
        Case state_Rectangle     ' Drawing a rectangle.
            picCanvas.Line (m_FirstX, m_FirstY)-(m_LastX, m_LastY), , B
        Case state_Circle        ' Drawing a circle.
            If Abs(m_FirstX - m_LastX) <= Abs(m_FirstY - m_LastY) Then
                r = Abs(m_FirstX - m_LastX) / 2
            Else
                r = Abs(m_FirstY - m_LastY) / 2
            End If
            picCanvas.Circle ((m_FirstX + m_LastX) / 2, (m_FirstY + m_LastY) / 2), r
        Case state_Line          ' Drawing a line.
            picCanvas.Line (m_FirstX, m_FirstY)-(m_LastX, m_LastY)
    End Select

    ' Update the last coordinates.
    m_LastX = X
    m_LastY = Y

    ' Draw the new object.
    Select Case m_State
        Case state_None          ' Not drawing.
        Case state_Rectangle     ' Drawing a rectangle.
            picCanvas.Line (m_FirstX, m_FirstY)-(m_LastX, m_LastY), , B
        Case state_Circle        ' Drawing a circle.
            If Abs(m_FirstX - m_LastX) <= Abs(m_FirstY - m_LastY) Then
                r = Abs(m_FirstX - m_LastX) / 2
            Else
                r = Abs(m_FirstY - m_LastY) / 2
            End If
            picCanvas.Circle ((m_FirstX + m_LastX) / 2, (m_FirstY + m_LastY) / 2), r
        Case state_Line          ' Drawing a line.
            picCanvas.Line (m_FirstX, m_FirstY)-(m_LastX, m_LastY)
    End Select
End Sub

' Create the new object.
Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim obj As Object
Dim r As Single

    If Not m_Drawing Then Exit Sub

    ' Create the new object.
    Select Case m_State
        Case state_None          ' Not drawing.
        Case state_Rectangle     ' Drawing a rectangle.
            Set obj = New draw_Rectangle
            With obj
                .X1 = m_FirstX
                .Y1 = m_FirstY
                .X2 = m_LastX
                .Y2 = m_LastY
                .Selected = True
            End With
        Case state_Circle        ' Drawing a circle.
            Set obj = New draw_Circle
            With obj
                .X0 = (m_FirstX + m_LastX) / 2
                .Y0 = (m_FirstY + m_LastY) / 2
                If Abs(m_FirstX - m_LastX) <= Abs(m_FirstY - m_LastY) Then
                    .Radius = Abs(m_FirstX - m_LastX) / 2
                Else
                    .Radius = Abs(m_FirstY - m_LastY) / 2
                End If
                .Selected = True
            End With
        Case state_Line          ' Drawing a line.
            Set obj = New draw_Line
            With obj
                .X1 = m_FirstX
                .Y1 = m_FirstY
                .X2 = m_LastX
                .Y2 = m_LastY
                .Selected = True
            End With
    End Select

    ' Add the new object to the collection.
    m_DrawingObjects.Add obj
    Set obj.picCanvas = picCanvas

    ' Stop drawing.
    m_Drawing = False
    m_State = state_None
    picCanvas.MousePointer = vbDefault
    picCanvas.DrawMode = vbCopyPen

    ' Select the new object.
    SelectObject obj

    ' Redraw.
    Redraw
End Sub
